<p>Zamislite jedan digitalni sklop koji na ulazu dobiva dva broja (označimo ih s <i>a</i> i <i>b</i>) a na svojem izlazu (označimo ga s <i>y</i>) daje vrijednost 1 ako je njihov zbroj paran a 0 inače. Vrijednosti koje može poprimiti broj <i>a</i> su iz skupa {0, 1, 2, 3}, dok su vrijednosti koje može poprimiti broj <i>b</i> iz skupa {0, 1}. Konceptualni prikaz ovakvog sklopa modelom crne kutije dan je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(parnasuma1.svg)" alt="Konceptualni prikaz sklopa modelom crne kutije." border="0">
<figcaption>Konceptualni prikaz sklopa modelom crne kutije.</figcaption>
</figure>

<p>Kako se radi o digitalnom sklopu, svi njegovi ulazi moraju biti binarni. Stoga ćemo omogućiti da se na sklop za broj <i>a</i> dovodi njegov binarni kod: vrijednosti 0, 1, 2 i 3 sve možemo kodirati prirodnim binarnim kodom uporabom dva bita. Stoga će naš digitalni sklop imati dvobitni ulaz <i>a</i> čije ćemo komponente označiti s <i>a</i><sub>1</sub> i <i>a</i><sub>0</sub> (bit <i>a</i><sub>1</sub> uzet ćemo kao bit veće težine). Uz takav dogovor, kada na sklop želimo dovesti <i>a</i>=0, ulaze <i>a</i><sub>1</sub><i>a</i><sub>0</sub> postavit ćemo na 00, kada želimo dovesti <i>a</i>=1, ulaze <i>a</i><sub>1</sub><i>a</i><sub>0</sub> postavit ćemo na 01, kada želimo dovesti <i>a</i>=2, ulaze <i>a</i><sub>1</sub><i>a</i><sub>0</sub> postavit ćemo na 10, a kada želimo dovesti <i>a</i>=3, ulaze <i>a</i><sub>1</sub><i>a</i><sub>0</sub> postavit ćemo na 11.</p>

<p>Broj <i>b</i> može poprimiti vrijednost 0 ili 1, pa njega izravno kao jedan bit možemo dovesti na ulaz digitalnog sklopa.</p>

<p>Prikaz digitalnog sklopa koji ima ovako definirano sučelje prema okolini dan je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(parnasuma2.svg)" alt="Prikaz sučelja digitalnog sklopa. Svi ulazi i izlazi su binarni podatci." border="0">
<figcaption>Prikaz sučelja digitalnog sklopa. Svi ulazi i izlazi su binarni podatci.</figcaption>
</figure>

<p>Ponašanje ovog sklopa formalno možemo opisati tako da odredimo Booleovu funkciju koju sklop ostvaruje. Ovaj sklop ima tri binarna ulaza: <i>a</i><sub>1</sub>, <i>a</i><sub>0</sub> i <i>b</i>, te jedan binarni izlaz: <i>y</i>. Vrijednost izlaza ovisi o tome što je dovedeno na ulaze: koji je broj <i>a</i> i koji je broj <i>b</i> te je li njihov zbroj paran ili nije. Konceptualno, izlaz <i>y</i> je funkcija od brojeva <i>a</i> i <i>b</i>. U binarnoj domeni imamo Booleovu funkciju <i>y</i> koja je funkcija od argumenata <i>a</i><sub>1</sub>, <i>a</i><sub>0</sub> i <i>b</i>. Stoga možemo pisati: \(y: \mathbb{B}^3 \rightarrow \mathbb{B}\).</p>

<p>Da bismo formalno specificirali Booleovu funkciju koju sklop ostvaruje, uz domenu i kodomenu koju smo upravo identificirali potrebno je odrediti i samo preslikavanje. Jedan način jest napisati tablicu istinitosti. Ta tablica prikazana je u nastavku. Tablica je interaktivna: kliknite na bilo koji redak tablice i vrijednosti ulaza i izlaza koje su dane u tom retku preslikat će se i na sklop prikazan lijevo od tablice.</p>


    <canvas id="myCanvas" width="750" height="290" style="margin-left: auto; margin-right: auto; display: block;"></canvas>
    <script>
      var canvas = document.getElementById('myCanvas');
      var context = canvas.getContext('2d');
      var state = {
        currentRow: 0,
        vars: 3,
        elems: [[0,0,0,0,0,0,"DA",1],[0,0,1,0,1,1,"NE",0],[0,1,0,1,0,1,"NE",0],[0,1,1,1,1,2,"DA",1],[1,0,0,2,0,2,"DA",1],[1,0,1,2,1,3,"NE",0],[1,1,0,3,0,3,"NE",0],[1,1,1,3,1,4,"DA",1]],
        labels: ["a1","a0","b","a","b","a+b","a+b paran?","y"],
        verticals: [1,2,0,1,0,1,1,1,1],
        userInput: [-1,-1,-1,-1,-1,-1,-1,-1],
        hots: []
      };

      canvas.addEventListener('mousedown', function(evt) {
        var rect = canvas.getBoundingClientRect();
        var pos = {x: evt.clientX - rect.left, y: evt.clientY - rect.top};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(pos.x>=h.x && pos.x<h.x+h.w && pos.y>=h.y && pos.y<h.y+h.h) {
            state.currentRow = h.row;
            draw(canvas, context, state);
            break;
          }
        }
      }, false);

      function draw(canvas, context, state) {
        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);

        // Draw circuit...

        var cloff = 100; var ctoff = 40; var cvertOut = 20; var cvertBetween = 50; var choriz = 100; var connector = 20;

        var cheight = 2*cvertOut + (state.vars-1)*cvertBetween;

        context.beginPath();
        context.strokeStyle = '#000000';
        for(var v = 0; v < state.vars; v++) {
          context.moveTo(cloff, ctoff+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector, ctoff+cvertOut+v*cvertBetween);
        }
        context.moveTo(cloff + connector + choriz, ctoff+cheight/2);
        context.lineTo(cloff + connector + choriz + connector, ctoff+cheight/2);
        context.stroke();

        context.beginPath();
        context.fillStyle = '#000000';
        context.rect(cloff + connector, ctoff, choriz, cheight);
        context.fill();


        var cfontSize = 14;
        context.font = 'normal '+cfontSize+'pt Calibri';
        context.textBaseline = 'middle';

        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'left';
          context.strokeText(state.labels[v], cloff + connector + 2, ctoff+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'right';
          context.strokeText(''+state.elems[state.currentRow][v], cloff - 2, ctoff+cvertOut+v*cvertBetween);
        }
        context.strokeStyle = '#ffffff';
        context.textAlign = 'right';
        context.strokeText('y', cloff + connector + choriz - 2, ctoff+cheight/2);
        context.strokeStyle = '#000000';
        context.textAlign = 'left';
        context.strokeText(''+state.elems[state.currentRow][state.labels.length-1], cloff + connector + choriz + connector + 2, ctoff+cheight/2);

        // Draw table...

        var rh = 30; var toff = 10; var loff = 340; var cw = 50;

        context.beginPath();
        context.strokeStyle = '#000000';
        context.rect(0, 0, canvas.width, canvas.height);
        context.stroke();

        var fontSize = 14;
        context.font = 'normal '+fontSize+'pt Calibri';

        var cws = [];
        var cwsCumul = [];
        for(var i = 0; i < state.labels.length; i++) {
          var actw = context.measureText(state.labels[i]).width;
          var curr = actw+20;
          cws.push(curr);
          cwsCumul.push(i==0 ? curr : curr + cwsCumul[i-1]);
        }
        var tableWidth = cwsCumul[state.labels.length-1];

        loff = canvas.width - tableWidth - 10;

        context.beginPath();
        context.rect(loff, toff, tableWidth, rh);
        context.fillStyle = '#cccccc';
        context.fill();

        context.beginPath();
        context.rect(loff, toff+(state.currentRow+1)*rh, tableWidth, rh);
        context.fillStyle = 'yellow';
        context.fill();

        context.strokeStyle = '#ff0000';
        for(var y = 0; y <= state.elems.length+1; y++) {
          context.lineWidth = (y<2||y==state.elems.length+1) ? 3 : 1;
          context.beginPath();
          context.moveTo(loff, y*rh+toff);
          context.lineTo(loff+tableWidth, y*rh+toff);
          context.stroke();
        }
        for(var x = 0; x <= state.elems[0].length; x++) {
          var left = x==0 ? 0 : cwsCumul[x-1];
          if(state.verticals[x]!=2) {
            context.lineWidth = (state.verticals[x]==0) ? 1 : 3;
            context.setLineDash(state.verticals[x]==0 ? [2,2] : []);
            context.beginPath();
            context.moveTo(loff+left, toff);
            context.lineTo(loff+left, (state.elems.length+1)*rh+toff);
            context.stroke();
          }
        }

        context.setLineDash([]);
        context.lineWidth = 1;

        context.textAlign = 'center';
        context.textBaseline = 'bottom';
        state.hots.length = 0;

        function handler(x,y,w,h,state,row) {
          this.x = x; this.y = y; this.w = w; this.h = h; this.state = state; this.row = row;
        }

        for(var y = 0; y < state.elems.length+1; y++) {
          if(y>0) {
            state.hots.push(new handler(loff,y*rh+toff,tableWidth,rh,state,y-1));
          }
          for(var x = 0; x < state.elems[0].length; x++) {
            var txt = y==0 ? state.labels[x] : ''+state.elems[y-1][x];
            var middle = x==0 ? cws[0]/2 : cwsCumul[x-1]+cws[x]/2;
            context.strokeText(txt, loff+middle, (y+1)*rh+toff-(rh-fontSize)/4);
          }
        }

      }

      draw(canvas, context, state);

      function getQuestionData() {
        return state.userInput[0]+"."+state.userInput[1]+"."+state.userInput[2]+"."+state.userInput[3];
      }
    </script>

<p>Prva tri stupca navode sve elemente domene: to su uređene trojke bitova. Četvrti i peti stupac dekodiraju binarne kombinacije ulaza: govore nam (u semantičkom smislu) što smo zapravo doveli na one konceptualne ulaze sklopa: koju vrijednost ima broj <i>a</i> a koju broj <i>b</i>. Šesti stupac prikazuje koliko iznosi njihov zbroj dok sedmi stupac govori je li taj zbroj paran. Konačno, posljednji stupac tablice u svakom retku sadrži vrijednost u koju funkcija <i>y</i> mora preslikati uređenu trojku koja se nalazi u tom retku. Ta vrijednost kodira naš zaključak: je li zbroj bio paran ili nije.</p>

<p>Čista tablica istinitosti (bez pomoćnih stupaca) prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica istinitosti funkcije \(y(a_1,a_0,b)\).</div>
<table class="mlTableCC mlTableVRl1">
<thead><tr><th>\(a_1\)</th><th>\(a_0\)</th><th>\(b\)</th><th>\(y(a_1,a_0,b)\)</th></tr></thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>1</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>1</td><td>1</td></tr>
</tbody>
</table>

<p>U nastavku ćemo Vas pitati da napišete tablicu istinitosti za sličan sklop pa je važno da dobro razumijete što smo napravili na ovoj stranici. Ako je potrebno, prođite još jednom kroz ovaj primjer.</p>


